<?php
if($setupStep == 0) {
	echo '<div style="text-align:center;">';
	echo 'Bienvenue à l\'assitant d\'installation du GM Editor en ligne.<br>';
	echo 'Welcome to the installation of the Online GM Editor.<br>';
	echo '<br>Pour une mise à niveau, veuillez conserver votre fichier config.php, à la même place qu\'à l\'habitude.<br>';
	echo 'For an update, you just need your file config.php in the same place as usual.<br>';
	echo '<br><a href="?step=1&lang=fr">Français</a> / <a href="?step=1&lang=en">English</a> ';
	echo '</div>';
}
if($setupStep == 1) {
	if(file_exists('../config.php')) {
		$setupConfigFound = 1;
		include '../config.php';
	}
}
if($setupStep == 2 && isset($_POST['setupSQLServer'])) {
	extract($_POST,EXTR_OVERWRITE);
	$db_server = $setupSQLServer;
	$db_name = $setupSQLName;
	$db_table = $setupSQLTable;
	$db_username = $setupSQLUser;
	$db_password = $setupSQLPass;
	include 'mysqli.php';
	if(!isset($setupSQLLoginError)) {
		// Create config2.php
		$setupConfigFile = fopen('../config2.php', "w");
		$setupConfigFileTxt = "<?php\n";
		$setupConfigFileTxt .= "$"."db_server = '$db_server';\n";
		$setupConfigFileTxt .= "$"."db_name = '$db_name';\n";
		$setupConfigFileTxt .= "$"."db_table = '$db_table';\n";
		$setupConfigFileTxt .= "$"."db_username = '$db_username';\n";
		$setupConfigFileTxt .= "$"."db_password = '$db_password';\n";
		$setupConfigFileTxt .= "?>";
		fwrite($setupConfigFile, $setupConfigFileTxt);
		fclose($setupConfigFile);
		// Check for config2.php exist
		if(file_exists('../config2.php')) {
			$setupConfigFileCreated = 1;
			// Check for database name exist
			$query = mysqli_query($con, "SELECT * FROM information_schema.SCHEMATA WHERE SCHEMA_NAME = '$setupSQLName'");
			if(mysqli_num_rows($query) > 0) {
				// Check for table name exist
				$query = mysqli_query($con, "SELECT * FROM information_schema.TABLES WHERE TABLE_SCHEMA = '$setupSQLName' AND TABLE_NAME = '$db_table'");
				if(mysqli_num_rows($query) == 0) {
					$sql = "CREATE TABLE $db_table (
					`INT` int( 11 ) NOT NULL AUTO_INCREMENT ,
					`EQUIPE` text NOT NULL ,
					`EQUIPESIM` text NOT NULL ,
					`DB_USER` text NOT NULL ,
					`USER` text NOT NULL ,
					`PASS` text NOT NULL ,
					`LAST` datetime NOT NULL ,
					`IP` text NOT NULL ,
					`LANGUE` text NOT NULL ,
					`SEND` text NOT NULL ,
					PRIMARY KEY ( `INT` )
					) DEFAULT CHARSET=utf8;";
					$query = mysqli_query($con, $sql);
				}
				else {
					// Teams List table already exist
					$setupTeamsListTableExist = 1;
				}
				// Check for table name gmo_parameters exist
				$query = mysqli_query($con, "SELECT * FROM information_schema.TABLES WHERE TABLE_SCHEMA = '$setupSQLName' AND TABLE_NAME = 'gmo_parameters'");
				if(mysqli_num_rows($query) == 0) {
					$sql = "CREATE TABLE gmo_parameters (
						`PARAM` text NOT NULL ,
						`VALUE` text NOT NULL
						) DEFAULT CHARSET=utf8;";
					$query = mysqli_query($con, $sql);
				}
				$query = mysqli_query($con, "SELECT * FROM information_schema.TABLES WHERE TABLE_SCHEMA = '$setupSQLName' AND TABLE_NAME = 'gmo_parameters'");
				if(mysqli_num_rows($query) > 0) {
					$sql = "TRUNCATE TABLE `gmo_parameters`";
					$query = mysqli_query($con, $sql);
					$sql = "INSERT INTO `gmo_parameters` (`PARAM`, `VALUE`) VALUES 
					('SessionName', 'GMO'), 
					('FHLSimVersion', '1'), 
					('file_folder', ''), 
					('file_folder_lines', 'lines/'), 
					('file_folder_temp_lines', 'lines/tempo/'), 
					('league_name', 'YOUR LEAGUE NAME'), 
					('league_langue', 'en'), 
					('league_cap', '0'), 
					('league_capType', '0'), 
					('league_GameInProPayroll', '0'), 
					('league_players', '0'), 
					('league_MaxPlayers', '0'), 
					('league_FarmMaxOV', '0'), 
					('league_AgeExemptFarmMaxOV', '0'),
					('league_FarmMaxAge', '0'),
					('league_GameInProWaivers', '0'), 
					('league_AgeExemptWaivers', '0'), 
					('league_OVSkatersWaivers', '0'), 
					('league_OVGoaliesWaivers', '0'), 
					('league_gmeditor', '1'), 
					('league_shootoutLock', '0'), 
					('colorTxtTtitle', '#FFFF00'), 
					('colorBackground', '#204080'), 
					('colorBorder', '#00A7FE'),
					('TimeZone', 'America/Toronto')
					;";
					$query = mysqli_query($con, $sql);
					$query = mysqli_query($con, "SELECT * FROM gmo_parameters");
					if(mysqli_num_rows($query) > 0) {
						$setupStep2TableCreated = 1;
						$query = mysqli_query($con, "SELECT * FROM $db_table WHERE EQUIPE != 'ADMIN'");
						if(mysqli_num_rows($query) > 0) {
							$setupStep2TeamsListExist = mysqli_num_rows($query);
						}
					}
					else {
						// Can't insert parameters in gmo_parameters table
						$setupSQLParamTableError = 2;
						$setupStep = $setupStep - 1;
					}
				}
				else {
					// Can't create the table gmo_parameters
					$setupSQLParamTableError = 1;
					$setupStep = $setupStep - 1;
				}
			}
			else {
				// Database name was not found
				$setupSQLNameError = 1;
				$setupStep = $setupStep - 1;
			}
		}
		else {
			// config2.php was not found
			$setupConfigFileCreated = 0;
			$setupStep = $setupStep - 1;
		}
	}
	else {
		// mySQL Login Error
		$setupStep1Error = 1;
		$setupStep = $setupStep - 1;
	}
	mysqli_close($con);
}
else {
	if($setupStep == 2 && !isset($_POST['setupSQLServer'])) {
		$setupBad = 1;
		$setupStep = 0;
	}
}

if($setupStep == 3) {
	include '../config2.php';
	include 'mysqli.php';
	if(!isset($_POST['setupSkip']) && isset($_FILES['userfile']) && is_uploaded_file($_FILES['userfile']['tmp_name'])) {
		$handle = fopen ($_FILES['userfile']['tmp_name'], "r");
		$contents = "";
		while(!feof($handle)) {
			$contents .= fread($handle, 8192);
		}
		fclose ($handle);
		$file_tms_get = bin2hex($contents);
		$j = 0;
		$i = 0;
		while($i != 100){
			$gmequipe2[$i] = substr($file_tms_get, $j, 20);
			$strLength = strlen($gmequipe2[$i]);
			$returnVal = '';
			for($k=0; $k<$strLength; $k += 2) {
				$dec_val = hexdec(substr($gmequipe2[$i], $k, 2));
				$returnVal .= chr($dec_val);
			}
			$gmequipe[$i] = trim($returnVal);
			$erreur = substr($file_tms_get, $j+506, 2);
			if((hexdec($erreur)>="32") && (hexdec($erreur)<="126")) $j = $j + 506;
			else $j = $j + 508;
			$i++;
		}
		if(count($gmequipe) > 0) {
			$sql = "DELETE FROM $db_table WHERE EQUIPE != 'ADMIN'"; 
			$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			$k = 0;
			for($i=0; $i<count($gmequipe); $i++) {
				if($gmequipe[$i] != '') {
					$capusername = strtoupper($gmequipe[$i]);
					$gmequipe[$i] = mysqli_real_escape_string($con, $gmequipe[$i]);
					$capusername = mysqli_real_escape_string($con, $capusername);
					$sql = "INSERT INTO $db_table (EQUIPE,EQUIPESIM,DB_USER,USER,PASS,LAST,IP,LANGUE,SEND) VALUES('$gmequipe[$i]','$gmequipe[$i]','','$capusername','none','0000-00-00 00:00:00','','$setupLang','')"; 
					$query = mysqli_query($con, $sql) or die(mysqli_error($con));
					$k++;
				}
			}
			$setupStep3AddTeams = 1;
		}
		else {
			// No team found in .tms
			$setupStep3TMSError = 1;
			$setupStep = $setupStep - 1;
		}
	}
	if($setupStep == 3) {
		$query = mysqli_query($con, "SELECT USER FROM $db_table WHERE EQUIPE != 'ADMIN'");
		if(mysqli_num_rows($query) > 0) {
			$setupStep3TeamsNumber = mysqli_num_rows($query);
		}
		$query = mysqli_query($con, "SELECT USER FROM $db_table WHERE EQUIPE = 'ADMIN'");
		if(mysqli_num_rows($query) > 0) {
			$setupStep3AdminUser = '';
			while($data = mysqli_fetch_array($query)) {
				if($setupStep3AdminUser != '') $setupStep3AdminUser .= ' - ';
				$setupStep3AdminUser .= $data['USER'];
			}
		}
		else {
			// Creating the admin account
			$admin_pass = md5('admin');
			$sql = "INSERT INTO $db_table (EQUIPE,EQUIPESIM,DB_USER,USER,PASS,LAST,IP,LANGUE,SEND) VALUES('ADMIN','','','ADMIN','$admin_pass','0000-00-00 00:00:00','','$setupLang','')"; 
			$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			$setupStep3AdminCreated = 1;
		}
		// Updating the gmo_parameters
		if(file_exists('../config.php')) {
			include '../config.php';
			if(isset($SessionName)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$SessionName' WHERE PARAM='SessionName'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($FHLSimVersion)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$FHLSimVersion' WHERE PARAM='FHLSimVersion'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($file_folder)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$file_folder' WHERE PARAM='file_folder'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($file_folder_lines)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$file_folder_lines' WHERE PARAM='file_folder_lines'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($file_folder_temp_lines)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$file_folder_temp_lines' WHERE PARAM='file_folder_temp_lines'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_name)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_name' WHERE PARAM='league_name'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_langue)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_langue' WHERE PARAM='league_langue'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_cap)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_cap' WHERE PARAM='league_cap'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_capType)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_capType' WHERE PARAM='league_capType'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_GameInProPayroll)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_GameInProPayroll' WHERE PARAM='league_GameInProPayroll'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_players)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_players' WHERE PARAM='league_players'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_MaxPlayers)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_MaxPlayers' WHERE PARAM='league_MaxPlayers'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_GameInProWaivers)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_GameInProWaivers' WHERE PARAM='league_GameInProWaivers'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_AgeExemptWaivers)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_AgeExemptWaivers' WHERE PARAM='league_AgeExemptWaivers'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_gmeditor)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_gmeditor' WHERE PARAM='league_gmeditor'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($league_shootoutLock)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$league_shootoutLock' WHERE PARAM='league_shootoutLock'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($colorTxtTtitle)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$colorTxtTtitle' WHERE PARAM='colorTxtTtitle'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($colorBackground)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$colorBackground' WHERE PARAM='colorBackground'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			if(isset($colorBorder)) {
				$sql = "UPDATE gmo_parameters SET VALUE='$colorBorder' WHERE PARAM='colorBorder'";
				$query = mysqli_query($con, $sql) or die(mysqli_error($con));
			}
			$setupStep3ParamUpdated = 1;
		}
		mysqli_close($con);
	}
}


if($setupStep == 0) {
	if(isset($setupBad) && $setupBad == 1) echo '<a href="?">'.$langSetupBad.'</a><br>';
}

$tmpSetupStep = $setupStep + 1;
echo '<form method="post" enctype="multipart/form-data" action="index.php?step='.$tmpSetupStep.'&lang='.$setupLang .'">';

if($setupStep == 1) {
	if(isset($setupSQLParamTableError) && $setupSQLParamTableError == 2) echo 'Can\'t create new parameters in database!<br>';
	if(isset($setupSQLNameError) && $setupSQLNameError == 1) echo $langSetupDBNameError.'<br>';
	if(isset($setupConfigFileCreated) && $setupConfigFileCreated == 0) echo $langSetupConfig2Error.'<br>';
	if(isset($setupStep1Error) && $setupStep1Error == 1) echo $langSetupDBLoginError.'<br>';
	if(isset($setupConfigFound) && $setupConfigFound == 1) echo $langSetupConfigFound.'<br>';
	echo '<br><br><span style="font-weight:bold;">'.$langSetupSQLCreating.'</span><br>';
	echo ''.$langSetupSQLServer.'<br>';
	$tmpSetupSQLServer = 'localhost';
	if(isset($db_server)) $tmpSetupSQLServer = $db_server;
	echo '<input placeholder="mySQL Server" name="setupSQLServer" style="width:150px;" value="'.$tmpSetupSQLServer.'" required><br>';
	echo '<br>'.$langSetupSQLDBName.'<br>';
	$tmpSetupSQLName = '';
	if(isset($db_name)) $tmpSetupSQLName = $db_name;
	echo '<input placeholder="mySQL Database Name" name="setupSQLName" style="width:150px;" value="'.$tmpSetupSQLName.'" required><br>';
	echo '<br>'.$langSetupSQLDBTable.'<br>';
	$tmpSetupSQLTable = 'gmo';
	if(isset($db_table)) $tmpSetupSQLTable = $db_table;
	echo '<input placeholder="mySQL Table Name" name="setupSQLTable" style="width:150px;" value="'.$tmpSetupSQLTable.'" required><br>';
	echo '<br>'.$langSetupSQLUser.'<br>';
	$tmpSetupSQLUsername = '';
	if(isset($db_username)) $tmpSetupSQLUsername = $db_username;
	echo '<input placeholder="mySQL Username" name="setupSQLUser" style="width:150px;" value="'.$tmpSetupSQLUsername.'" required><br>';
	echo '<br>'.$langSetupSQLPass.'<br>';
	$tmpSetupSQLPassword = '';
	if(isset($db_password)) $tmpSetupSQLPassword = $db_password;
	echo '<input placeholder="mySQL Password" name="setupSQLPass" style="width:150px;" value="'.$tmpSetupSQLPassword.'"><br>';
	echo '<br><input type="submit" value="'.$langSetupNext.'" name="setupNext">';
}

if($setupStep == 2) {
	if(isset($setupConfigFileCreated) && $setupConfigFileCreated == 1) echo $langSetupConfig2Created.'<br>';
	if(isset($setupStep2TableCreated) && $setupStep2TableCreated == 1) echo $langSetupDBParamCreated.'<br>';
	
	if(isset($setupStep2TeamsListExist) && $setupStep2TeamsListExist != 0) echo '<br>'.$langSetupDBTeamsFound.' ('.$setupStep2TeamsListExist.') <input name="setupSkip" type="submit" value="'.$langSetupSkip.'" formnovalidate><br>';
	
	echo '<br><br><span style="font-weight:bold;">'.$langSetupTMSTitle.'</span><br>';
	if(isset($setupStep2TeamsListExist) && $setupStep2TeamsListExist != 0) echo $langSetupTMSTitle2.'<br>';
	echo '<br><input type="file" name="userfile" accept=".tms" required><br>';
	echo '<br><input type="submit" value="'.$langSetupNext.'" name="setupNext">';
}

if($setupStep == 3) {
	if(isset($setupStep3ParamUpdated) && $setupStep3ParamUpdated == 1) echo $langSetupDBParamTransfer.'<br>';
	if(isset($setupStep3AdminCreated) && $setupStep3AdminCreated == 1) echo $langSetupDBTeamsAdminNew.'<br>';
	if(isset($setupStep3AdminUser) && $setupStep3AdminUser != '') echo $langSetupDBTeamsAdmin.' '.$setupStep3AdminUser.'.<br>';
	if(isset($setupStep3TeamsNumber) && isset($setupStep3AddTeams) && $setupStep3AddTeams == 1) echo $langSetupTMSCreated.' '.$setupStep3TeamsNumber.'.<br>';
	if(isset($setupStep3TeamsNumber) && $setupStep3TeamsNumber != 0) echo $langSetupTMSListed.' '.$setupStep3TeamsNumber.'.<br>';
	
	echo '<br>'.$langSetupCompleted.'<br>';
	echo '<br>'.$langSetupCompletedButton.' <input type="submit" value="'.$langSetupConn.'" name="setupLogin"><br>';
	echo '<br><a href="?">'.$langSetupCompletedRestart.'</a><br>';
	
	include '../config2.php';
	include 'mysqli.php';
	
	echo '<table style="border:1px solid #000000; float:left; margin-right:15px; margin-top:15px;">';
	echo '<tr><td style="border:1px solid #000000; font-weight:bold;">FHLsim Team List</td><td style="border:1px solid #000000; font-weight:bold;">Valid password</td></tr>';
	$sql = "SELECT `EQUIPESIM`, `PASS` FROM $db_table WHERE `EQUIPE`!='ADMIN'";
	$query = mysqli_query($con, $sql) or die(mysqli_error($con));
	while($data = mysqli_fetch_array($query)) {
		$tmpPass = 'No';
		if($data['PASS'] != 'none') $tmpPass = 'Yes';
		echo '<tr><td style="border:1px solid #000000;">'.$data['EQUIPESIM'].'</td><td style="border:1px solid #000000;">'.$tmpPass.'</td></tr>';
	}
	echo '</table>';
	echo '<table style="border:1px solid #000000; float:left; margin-top:15px;">';
	echo '<tr><td style="border:1px solid #000000; font-weight:bold;">Param</td><td style="border:1px solid #000000; font-weight:bold;">Value</td></tr>';
	$sql = "SELECT `PARAM`, `VALUE` FROM gmo_parameters";
	$query = mysqli_query($con, $sql) or die(mysqli_error($con));
	while($data = mysqli_fetch_array($query)) {
		echo '<tr><td style="border:1px solid #000000;">'.$data['PARAM'].'</td><td style="border:1px solid #000000;">'.$data['VALUE'].'</td></tr>';
	}
	echo '</table>';
	
	echo '<div style="clear:both;"></div>';
	
	mysqli_close($con);
}



echo '</form>';

?>